/***************************************************************************
 * File:          compiler.h
 * Description:   This file include all compiler options
 * Author:        DaHai Huang    (DH)
 * Dependence:    none
 * Copyright (c)  2000 HighPoint Technologies, Inc. All rights reserved
 * History:       DH 5/10/2000 initial code
 *
 ***************************************************************************/

#ifndef _COMPILER_H_
#define _COMPILER_H_

/* this shall be moved to elsewhere... */


/*
 * Langurage selection
 */
#define ENGLISH    1
#define CHINESE    2
#define JAPANESE   3

/* 
 * function selection 
 */
#define HPT_INTERFACE_VERSION 0x01010000
#define SUPPORT_HPT3XX
#define HPT3XX_IO_ENABLE   /* for special products */
#define HPT3XX_SATA_RESET  /* for special products */
/*#define SUPPORT_ARRAY */
/*#define SUPPORT_OLD_ARRAY */
/*#define SUPPORT_RAID5 0 */
#define SCAN_ALL_AT_BEGINNING
#define MAX_SG_DESCRIPTORS  18
#define OS_PROVIDE_ADDR_MAPPING
#define OS_PROVIDE_TIMER
#define SUPPORT_48BIT_LBA
#define MAX_QUEUE_COMM 32
#define SUPPORT_IOCTL
/*#define SUPPORT_ATAPI */
#define SUPPORT_REMOVABLE_DISK
#define SUPPORT_DPLL
#define CLOCK_66MHZ
/*#define SERIAL_CMDS */

/***************************************************************************
 * product special 
 ***************************************************************************/

#define VERSION       "v1.0s"
#define COMPANY      "HighPoint Technologies, Inc."
#define PRODUCT_NAME "Rocket 1540"
#define COPYRIGHT    "(c) 2000-2003. HighPoint Technologies, Inc."
#define UTILITY      "BIOS Setting Utility"
#define WWW_ADDRESS  "www.highpoint-tech.com"
#define CHECK_SATA_DEVICE(pDev) pDev->df_sata=1
#define IS_SUPPORTED_DEVICEID(x) ((WORD)(x)==8)

/***************************************************************************
 * Description: Consistent check
 ***************************************************************************/

#ifndef LANGURAGE
#define LANGURAGE ENGLISH
#endif

#define SCAN_PCI_BUS_FOR_DEVICE


/***************************************************************************
 * Description: Data structure size
 ***************************************************************************/

/*
 * how many chips, channels and devices we will sopport
 */
#ifndef MAX_CHIPS
#define MAX_CHIPS   4
#endif

#ifndef MAX_CHANNEL_PER_CHIP
#define MAX_CHANNEL_PER_CHIP 2
#endif

#ifndef MAX_CHANNELS
#define MAX_CHANNELS (MAX_CHIPS * MAX_CHANNEL_PER_CHIP)
#endif

/* 2001-11-5 zhoulch merge from wx */
#ifndef MAX_DEVICE_PER_CHANNEL		
#define MAX_DEVICE_PER_CHANNEL 2
#endif

#ifndef MAX_DEVICES
#define MAX_DEVICES  (MAX_CHANNELS * 2)
#endif


#ifndef MAX_ARRAY_DEVICE
#define MAX_ARRAY_DEVICE   MAX_DEVICES
#endif

/*
 * how many VBUS we will support
 */

#ifndef MAX_CHIP_IN_VBUS
#define MAX_CHIP_IN_VBUS	MAX_CHIPS
#endif

#ifndef MAX_VDEVICE_PER_VBUS
#define MAX_VDEVICE_PER_VBUS MAX_DEVICES
#endif

/*
 * Data structure size
 */
#ifndef MAX_SG_DESCRIPTORS
#define MAX_SG_DESCRIPTORS 17
#endif

#ifndef MAX_ARRAY_NAME
#define MAX_ARRAY_NAME    16 /* can't >16, see hptintf.h */
#endif

#ifndef MAX_MEMBERS
#define MAX_MEMBERS       8  /* Maximum members in an array	*/
#endif

#ifndef MAX_QUEUE_COMM
#define MAX_QUEUE_COMM 2 /* at least 2? can be 1 now */
#endif

#endif
